<?php

namespace Drupal\files_and_folders\TwigExtension;

use Twig\Extension\AbstractExtension;
use Twig\TwigFilter;

class FileIconExtension extends AbstractExtension {

  public function getFilters() {
    return [
      new TwigFilter('get_file_icon', [$this, 'getFileIcon']),
    ];
  }

  public function getFileIcon($filename) {
    // Implémentez la logique pour obtenir l'icône du fichier basée sur son extension
    $extension = pathinfo($filename, PATHINFO_EXTENSION);
    // Retournez l'emoji ou le chemin de l'icône approprié
    switch (strtolower($extension)) {
      case 'pdf':
        return '📄';
      case 'doc':
      case 'docx':
        return '📝';
      case 'xls':
      case 'xlsx':
        return '📊';
      case 'ppt':
      case 'pptx':
        return '📽️';
      case 'jpg':
      case 'jpeg':
      case 'png':
      case 'gif':
        return '🖼️';
      default:
        return '📎';
    }
  }

  public function getName() {
    return 'files_and_folders.file_icon';
  }
}